# $Id: Login.py,v 1.3 2005/03/27 17:06:43 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/ImageWidget/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.3 $"
__date__       = "$Date: 2005/03/27 17:06:43 $"
__copyright__  = "Copyright (c) 2004-2006 Aaron Straup Cope. GNU GPL 2"

import wx

from ImageWidget.Constants import *

class ImageWidgetLogin (wx.Dialog) :

    def __init__ (self,parent,id,title=u"",username=u"",password=u""):

	# wxTE_PROCESS_TAB

	self.user = username
	self.pswd = password
	self.save = False

        wx.Dialog.__init__(self,parent,-1,title)
        (min_x,min_y) = self.GetBestSize()

        #

        ctrl_user = wx.TextCtrl(self,
				IMAGEWIDGET_LOGIN_ID_USERNAME,
				username,
				size = (min_x,-1))

        ctrl_pswd = wx.TextCtrl(self,
				IMAGEWIDGET_LOGIN_ID_PASSWORD,
				password,
				(-1,-1),
				(min_x,-1),
				wx.TE_PASSWORD)
        
        ctrl_save = wx.CheckBox(self,
				IMAGEWIDGET_LOGIN_ID_SAVEAUTH,
				IMAGEWIDGET_LOGIN_LABEL_SAVEAUTH)

        ctrl_ok = wx.Button(self,
			    IMAGEWIDGET_LOGIN_ID_OK,
			    IMAGEWIDGET_LOGIN_LABEL_OK)

        ctrl_cancel = wx.Button(self,
				IMAGEWIDGET_LOGIN_ID_CANCEL,
				IMAGEWIDGET_LOGIN_LABEL_CANCEL)
        
	#

        spacer = wx.Size(5,5)

	sz_body = wx.BoxSizer(wx.VERTICAL)

	sz_body.Add(wx.StaticText(self,
				  -1,
				  IMAGEWIDGET_LOGIN_LABEL_USERNAME),
		    0,wx.ALIGN_LEFT)

	sz_body.Add(spacer)

	sz_body.Add(ctrl_user)

	sz_body.Add(spacer)

	sz_body.Add(wx.StaticText(self,
				  -1,
				  IMAGEWIDGET_LOGIN_LABEL_PASSWORD),
		    0,wx.ALIGN_LEFT)

	sz_body.Add(spacer)

	sz_body.Add(ctrl_pswd)
	sz_body.Add(spacer)

	sz_body.Add(ctrl_save)
	sz_body.Add(spacer)

        sz_control = wx.BoxSizer(wx.HORIZONTAL)
        sz_control.Add(ctrl_ok)
        sz_control.Add(spacer)
        sz_control.Add(ctrl_cancel)

        sz_body.Add(sz_control,0,wx.ALIGN_RIGHT)

	#

	spacer_h = wx.Size(10,1)
	spacer_v = wx.Size(1,10)

	sz_border_h = wx.BoxSizer(wx.HORIZONTAL)
	sz_border_h.Add(spacer_h)
	sz_border_h.Add(sz_body)
	sz_border_h.Add(spacer_h)

	sz_main = wx.BoxSizer(wx.VERTICAL)
	sz_main.Add(spacer_v)
	sz_main.Add(sz_border_h)
	sz_main.Add(spacer_v)

	#

	self.SetSizer(sz_main)
        self.SetAutoLayout(1)        

        sz_main.Fit(self)

	#

        ctrl_user.SetFocus()
        
        #

        wx.EVT_TEXT(self,
		    IMAGEWIDGET_LOGIN_ID_USERNAME,
		    self._Username)

        wx.EVT_TEXT(self,
		    IMAGEWIDGET_LOGIN_ID_PASSWORD,
		    self._Password)

        wx.EVT_CHECKBOX(self,
			IMAGEWIDGET_LOGIN_ID_SAVEAUTH,
			self._Save)
        
	wx.EVT_BUTTON(self,
		      IMAGEWIDGET_LOGIN_ID_OK,
		      self.OnOk)

        wx.EVT_BUTTON(self,
		      IMAGEWIDGET_LOGIN_ID_CANCEL,
		      self.OnCancel)

	# FIX ME - better tabbing between dialog items
        
    #
    
    def _Username (self,event) :
	self.user = event.GetString()

    def _Password (self,event) :
	self.pswd = event.GetString()

    def _Save (self,event) :
	self.save = event.IsChecked ()

    #

    def OnCancel (self,event) :
	self.result = None
	self.EndModal(wx.ID_CANCEL)

    def OnOk (self,event) :
	self.result = {'user':self.user,
		       'pswd':self.pswd,
		       'save':self.save};
	self.EndModal(wx.ID_OK)
