
# $Id: Widget.py,v 1.13 2005/12/31 15:43:55 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/ImageWidget/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.13 $"
__date__       = "$Date: 2005/12/31 15:43:55 $"
__copyright__  = "Copyright (c) 2004-2006 Aaron Straup Cope. GNU GPL 2"

import wx
import os
import thread

from time import sleep

from ImageWidget.Constants import *

from ImageWidget.Config     import ImageWidgetConfig
from ImageWidget.Frame      import ImageWidgetFrame
from ImageWidget.Error      import ImageWidgetError
from ImageWidget.Connection import ImageWidgetConnection
from ImageWidget.Filenames  import filename_preferences

# There's a wx. constant for this but
# I can't get it to work properly

wx.wxConvCurrent = "utf8"

class ImageWidget (wx.App):

    def OnInit (self) :
	
        wx.InitAllImageHandlers()

	frame = self.Setup(IMAGEWIDGET_APP_NAME,IMAGEWIDGET_NAMESPACE)
	
	# hack - see below
	frame._parent = self;
	frame.Setup();

        #
        
	self.Run();
	return True;
    
    #
    #
    #
    
    def Setup (self, name, uri) :

        prefs = filename_preferences(name)
        
	self.__cfg__  = ImageWidgetConfig(uri,prefs)
        self.__conn__ = ImageWidgetConnection ()
        
        #

	try :
	    self.__cfg__ = ImageWidgetConfig(uri,prefs)
	except Exception, e:
	    raise Error(IMAGEWIDGET_ERR_GETCONFIG,e)

	return self.CreateFrame(name)

    #
    #
    #
    
    def CreateFrame (self,title=IMAGEWIDGET_APP_NAME) :

	cfg   = self.Config()
	ns    = cfg.nsCfg()

	#

	pos_x = int(cfg.GetPref(ns[IMAGEWIDGET_CFG_POSX]))
	pos_y = int(cfg.GetPref(ns[IMAGEWIDGET_CFG_POSY]))

	if pos_x and pos_y :
	    pos = wx.Point(pos_x,pos_y)
	else :
	    pos = IMAGEWIDGET_DEFAULT_POS

	#

	sz_x = int(IMAGEWIDGET_DEFAULT_SZX)
	sz_y = int(IMAGEWIDGET_DEFAULT_SZY)

	if sz_y and sz_x :
	    sz = wx.Size(sz_x,sz_y)
	elif sz_y :
	    sz = wx.Size(IMAGEWIDGET_DEFAULT_SZX,sz_y)
	elif sz_x :
	    sz = wx.Size(sz_x,IMAGEWIDGET_DEFAULT_SZY)
	else :
	    sz = DEFAULT_SZ

	#

	return ImageWidgetFrame(None,IMAGEWIDGET_ID_APP,title,pos,sz)

    #
    #
    #
    
    def GetMaxDimensions (self) :
	cfg   = self.Config()
	ns    = cfg.nsCfg()
	sz_x  = int(cfg.GetPref(ns[IMAGEWIDGET_CFG_MAXHEIGHT]))
	sz_y  = int(cfg.GetPref(ns[IMAGEWIDGET_CFG_MAXWIDTH]))
	return (sz_x,sz_y)

    #
    #
    #
    
    def Config (self) :
	return self.__cfg__

    #
    #
    #
    
    def GetConfig (self,prop) :
	return self.__cfg__.GetPref(prop)

    #
    #
    #
    
    def SetConfig (self,prop,value) :
	return self.__cfg__.SetPref(prop,value)	

    #
    #
    #
    
    def Run (self) : 
        frame = self.GetTopWindow()
        
        while frame and frame.Panel :
        
	    if frame.Paused == True:
                wx.SafeYield(frame,True)

            else:

                if self.__conn__.TestConnection () :
                    frame.DisplayRandom()
                    thread.start_new_thread(frame.CollectNextImage,(True,))
                else :
                    self.ReportError(IMAGEWIDGET_ERR_NONET)
                    pass

                for i in range(IMAGEWIDGET_COUNTER_DELAY) :
                    sleep(IMAGEWIDGET_SECONDS_SLEEP)

                    if frame and frame.Panel:
                        if frame.Paused == True :
                            break
                        elif frame.ShowNext == True :
                            frame.ShowNext = False
                            break
                        else:
                            self.Yield(True)
                    else:
                        break               

    #
    #
    #
    
    def GetImage (self) :
	raise ImageWidgetError(IMAGEWIDGET_ERR_UNDEFINEDMETHOD,"getImage")

    #
    # This all seems wrong...but it works
    #
    
    def About (self,event,title,body) :
	self.GetTopWindow().About(event,title,body)    

    #
    #
    #
    
    def GetCurrentPhoto (self) :
	photo = self.GetTopWindow().Data;

        if photo.has_key('uid') == False :
	    raise ImageWidget.Error.Error(IMAGEWIDGET_ERR_CURRENTPHOTO)

	return photo

    #
    #
    #
    
    def Log (self,level,msg) :
	self.GetTopWindow().Log(level,msg);	

    #
    #
    #
    
    def ReportActivity (self,msg) :
	self.GetTopWindow().ReportActivity(msg);

    #
    #
    #
    
    def ReportError (self,msg,exception=None) :
	self.GetTopWindow().ReportError(msg,exception);

    #
    # This probably shouldn't go here...
    #
    
    def GetKeyDown (self,event) :
	if event.CmdDown():
            keycode = event.GetKeyCode()
        else:
            return ""
        
        if keycode <= 256:
            return chr(keycode)
        else:
            return ""

    #
    #
    #

    def OnDisplay (self) :
        pass

    def OnNext (self, event) :
        pass

    def OnPause (self, event) :
        pass

    def OnQuit (self, event) :
        pass

    def OnNext (self, event) :
        pass

    #
    #
    #
    
if __name__ == "__main__":
    app = ImageWidget ();
    app.MainLoop();
    
